diff -Naur gcc-4.7.1.orig/gcc/ChangeLog.rtems gcc-4.7.1/gcc/ChangeLog.rtems
--- gcc-4.7.1.orig/gcc/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7.1/gcc/ChangeLog.rtems	2012-06-14 14:07:46.894295665 +0200
@@ -0,0 +1,51 @@
+2012-04-19	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config.gcc (microblaze*-*-rtems*): New target.
+	* config/microblaze/rtems.h: New.
+	* config/microblaze/t-rtems: New.
+
+2011-10-28	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/avr/rtems.h: Remove __USE_INIT_FINI__.
+
+2011-06-20	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* sparc/t-rtems: Reflect introduction of sparc/t-crtin.
+
+2011-03-23	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* config.gcc (sparc-*-rtems*, sparc64-*-rtems*):
+	Add sparc/t-rtems, crti.o crtn.o.
+	* config/sparc/t-rtems: New.
+
+2011-03-22	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config.gcc (sparc64-rtems*): Remove sysv.h from tm_file.
+
+2010-05-19  Joel Sherrill <joel.sherrill@oarcorp.com>
+
+    	* config.gcc (sparc64-*-rtems*): New target.
+	* config/sparc/sp64-rtemself.h: New file.
+
+2010-04-19	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _X86_64_ANSI_H_ is 
+	defined (Used by amd64-*-netbsdelf5.*).
+
+2010-04-18	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _I386_ANSI_H_ is 
+	defined (Used by i386-*-netbsdelf5.*).
+
+2009-11-04	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/m32c/rtems.h, config/m68k/rtemself.h,
+	config/m68k/rtemself.h, config/sh/rtemself.h,
+	config/sparc/rtemself.h: Undef WCHAR_TYPE_SIZE, WCHAR_TYPE. 
+	(Resets WCHAR_TYPE's to defaults. Prevents broken GCC tm_files 
+	to interfere and cause wchar_t/wint_t incompatibilities).
+
+		Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/mips/elf.h: Remove NO_IMPLICIT_EXTERN_C.
+	
diff -Naur gcc-4.7.1.orig/gcc/config/avr/rtems.h gcc-4.7.1/gcc/config/avr/rtems.h
--- gcc-4.7.1.orig/gcc/config/avr/rtems.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.7.1/gcc/config/avr/rtems.h	2012-06-14 14:07:46.895295686 +0200
@@ -23,6 +23,5 @@
 #define TARGET_OS_CPP_BUILTINS()	\
 do {					\
   builtin_define ("__rtems__");		\
-  builtin_define ("__USE_INIT_FINI__");	\
   builtin_assert ("system=rtems");	\
 } while (0)
diff -Naur gcc-4.7.1.orig/gcc/config/avr/t-rtems gcc-4.7.1/gcc/config/avr/t-rtems
--- gcc-4.7.1.orig/gcc/config/avr/t-rtems	2004-11-23 04:44:03.000000000 +0100
+++ gcc-4.7.1/gcc/config/avr/t-rtems	2012-06-14 14:07:46.895295686 +0200
@@ -1,3 +1,4 @@
 # Multilibs for avr RTEMS targets.
 
-# ATM, this is just a stub
+# RTEMS uses _exit from newlib
+LIB1ASMFUNCS := $(filter-out _exit,$(LIB1ASMFUNCS))
diff -Naur gcc-4.7.1.orig/gcc/config/h8300/h8300.h gcc-4.7.1/gcc/config/h8300/h8300.h
--- gcc-4.7.1.orig/gcc/config/h8300/h8300.h	2011-07-20 00:34:31.000000000 +0200
+++ gcc-4.7.1/gcc/config/h8300/h8300.h	2012-06-14 14:07:46.895295686 +0200
@@ -129,6 +129,7 @@
 #define INCOMING_FRAME_SP_OFFSET   (POINTER_SIZE / 8)
 
 #define DWARF_CIE_DATA_ALIGNMENT	2
+#define DWARF2_ADDR_SIZE		4
 
 /* Define this if addresses of constant functions
    shouldn't be put through pseudo regs where they can be cse'd.
diff -Naur gcc-4.7.1.orig/gcc/config/m32c/rtems.h gcc-4.7.1/gcc/config/m32c/rtems.h
--- gcc-4.7.1.orig/gcc/config/m32c/rtems.h	2008-12-01 17:34:42.000000000 +0100
+++ gcc-4.7.1/gcc/config/m32c/rtems.h	2012-06-14 14:07:46.896295705 +0200
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.7.1.orig/gcc/config/m68k/rtemself.h gcc-4.7.1/gcc/config/m68k/rtemself.h
--- gcc-4.7.1.orig/gcc/config/m68k/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.7.1/gcc/config/m68k/rtemself.h	2012-06-14 14:07:46.896295705 +0200
@@ -31,3 +31,8 @@
 	builtin_assert ("system=rtems");	\
     }						\
   while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.7.1.orig/gcc/config/microblaze/rtems.h gcc-4.7.1/gcc/config/microblaze/rtems.h
--- gcc-4.7.1.orig/gcc/config/microblaze/rtems.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7.1/gcc/config/microblaze/rtems.h	2012-06-14 14:07:46.896295705 +0200
@@ -0,0 +1,25 @@
+/* Definitions for rtems targeting a microblaze using ELF.
+   Copyright (C) 2012 Free Software Foundation, Inc.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+/* Specify predefined symbols in preprocessor.  */
+
+#define TARGET_OS_CPP_BUILTINS() do {		\
+  builtin_define( "__rtems__" );		\
+  builtin_assert( "system=rtems" );		\
+} while (0)
diff -Naur gcc-4.7.1.orig/gcc/config/microblaze/t-rtems gcc-4.7.1/gcc/config/microblaze/t-rtems
--- gcc-4.7.1.orig/gcc/config/microblaze/t-rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7.1/gcc/config/microblaze/t-rtems	2012-06-14 14:07:46.897295728 +0200
@@ -0,0 +1 @@
+# Custom multilibs for RTEMS
diff -Naur gcc-4.7.1.orig/gcc/config/mips/elf.h gcc-4.7.1/gcc/config/mips/elf.h
--- gcc-4.7.1.orig/gcc/config/mips/elf.h	2010-11-21 01:54:14.000000000 +0100
+++ gcc-4.7.1/gcc/config/mips/elf.h	2012-06-14 14:07:46.897295728 +0200
@@ -47,5 +47,3 @@
 
 #undef  ENDFILE_SPEC
 #define ENDFILE_SPEC "crtend%O%s crtn%O%s"
-
-#define NO_IMPLICIT_EXTERN_C 1
diff -Naur gcc-4.7.1.orig/gcc/config/rs6000/rtems.h gcc-4.7.1/gcc/config/rs6000/rtems.h
--- gcc-4.7.1.orig/gcc/config/rs6000/rtems.h	2011-12-06 23:49:57.000000000 +0100
+++ gcc-4.7.1/gcc/config/rs6000/rtems.h	2012-06-14 14:07:46.897295728 +0200
@@ -69,3 +69,7 @@
           rs6000_spe_abi = 1;                                             \
       }                                                                   \
   } while(0)
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.7.1.orig/gcc/config/sh/rtemself.h gcc-4.7.1/gcc/config/sh/rtemself.h
--- gcc-4.7.1.orig/gcc/config/sh/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.7.1/gcc/config/sh/rtemself.h	2012-06-14 14:07:46.898295758 +0200
@@ -24,3 +24,8 @@
   builtin_define( "__rtems__" );		\
   builtin_assert( "system=rtems" );		\
 } while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.7.1.orig/gcc/config/sparc/rtemself.h gcc-4.7.1/gcc/config/sparc/rtemself.h
--- gcc-4.7.1.orig/gcc/config/sparc/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.7.1/gcc/config/sparc/rtemself.h	2012-06-14 14:07:46.898295758 +0200
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.7.1.orig/gcc/config/sparc/sp64-rtemself.h gcc-4.7.1/gcc/config/sparc/sp64-rtemself.h
--- gcc-4.7.1.orig/gcc/config/sparc/sp64-rtemself.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7.1/gcc/config/sparc/sp64-rtemself.h	2012-06-14 14:07:46.898295758 +0200
@@ -0,0 +1,37 @@
+/* Definitions for rtems targeting a SPARC64 using ELF.
+   Copyright (C) 2010 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+/* Target OS builtins.  */
+#undef TARGET_OS_CPP_BUILTINS
+#define TARGET_OS_CPP_BUILTINS()		\
+  do						\
+    {						\
+	builtin_define ("__rtems__");		\
+	builtin_define ("__USE_INIT_FINI__");	\
+	builtin_assert ("system=rtems");	\
+    }						\
+  while (0)
+
+/* Use the default */
+#undef LINK_GCC_C_SEQUENCE_SPEC
+
+/* we are not svr4 */
+#undef CPP_SUBTARGET_SPEC
+#define CPP_SUBTARGET_SPEC ""
diff -Naur gcc-4.7.1.orig/gcc/config/sparc/t-rtems gcc-4.7.1/gcc/config/sparc/t-rtems
--- gcc-4.7.1.orig/gcc/config/sparc/t-rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7.1/gcc/config/sparc/t-rtems	2012-06-14 14:07:46.898295758 +0200
@@ -0,0 +1,18 @@
+# Copyright (C) 2011 Free Software Foundation, Inc.
+#
+# This file is part of GCC.
+#
+# GCC is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# GCC is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GCC; see the file COPYING3.  If not see
+# <http://www.gnu.org/licenses/>.
+#
diff -Naur gcc-4.7.1.orig/gcc/config.gcc gcc-4.7.1/gcc/config.gcc
--- gcc-4.7.1.orig/gcc/config.gcc	2012-06-04 11:51:00.000000000 +0200
+++ gcc-4.7.1/gcc/config.gcc	2012-06-14 14:07:46.899295783 +0200
@@ -1711,6 +1711,14 @@
 	c_target_objs="${c_target_objs} microblaze-c.o"
 	cxx_target_objs="${cxx_target_objs} microblaze-c.o"
 	;;
+microblaze*-*-rtems*)
+	tm_file="${tm_file} dbxelf.h"
+	tm_file="${tm_file} microblaze/rtems.h rtems.h newlib-stdint.h"
+	c_target_objs="${c_target_objs} microblaze-c.o"
+	cxx_target_objs="${cxx_target_objs} microblaze-c.o"
+	tmake_file="${tmake_file} microblaze/t-microblaze"
+	tmake_file="${tmake_file} t-rtems microblaze/t-rtems"
+        ;;
 microblaze*-*-*)
         tm_file="${tm_file} dbxelf.h"
 	c_target_objs="${c_target_objs} microblaze-c.o"
@@ -2392,7 +2400,8 @@
 	;;
 sparc-*-rtems*)
 	tm_file="${tm_file} dbxelf.h elfos.h sparc/sysv4.h sparc/sp-elf.h sparc/rtemself.h rtems.h newlib-stdint.h"
-	tmake_file="sparc/t-sparc sparc/t-elf t-rtems"
+	tmake_file="sparc/t-sparc sparc/t-elf sparc/t-rtems t-rtems"
+	extra_parts="crtbegin.o crtend.o"
 	;;
 sparc-*-linux*)
 	tm_file="${tm_file} dbxelf.h elfos.h sparc/sysv4.h gnu-user.h linux.h glibc-stdint.h sparc/tso.h"
@@ -2445,8 +2454,9 @@
 sparc64-*-rtems*)
 	tm_file="${tm_file} dbxelf.h elfos.h newlib-stdint.h sparc/sysv4.h sparc/sp64-elf.h sparc/rtemself.h rtems.h"
 	extra_options="${extra_options}"
-	tmake_file="${tmake_file} sparc/t-sparc t-rtems"
-	;;
+	tmake_file="${tmake_file} sparc/t-crtin sparc/t-crtfm sparc/t-rtems t-rtems"
+	extra_parts="crtbegin.o crtend.o"
+ 	;;
 sparc64-*-linux*)
 	tm_file="sparc/biarch64.h ${tm_file} dbxelf.h elfos.h sparc/sysv4.h gnu-user.h linux.h glibc-stdint.h sparc/default-64.h sparc/linux64.h sparc/tso.h"
 	extra_options="${extra_options} sparc/long-double-switch.opt"
diff -Naur gcc-4.7.1.orig/gcc/ginclude/stddef.h gcc-4.7.1/gcc/ginclude/stddef.h
--- gcc-4.7.1.orig/gcc/ginclude/stddef.h	2012-02-12 02:06:04.000000000 +0100
+++ gcc-4.7.1/gcc/ginclude/stddef.h	2012-06-14 14:07:46.900295803 +0200
@@ -53,7 +53,13 @@
    one less case to deal with in the following.  */
 #if defined (__BSD_NET2__) || defined (____386BSD____) || (defined (__FreeBSD__) && (__FreeBSD__ < 5)) || defined(__NetBSD__)
 #include <machine/ansi.h>
+#if !defined(_MACHINE_ANSI_H_)
+#if defined(_I386_ANSI_H_) || defined(_X86_64_ANSI_H_)
+#define _MACHINE_ANSI_H_
 #endif
+#endif
+#endif
+
 /* On FreeBSD 5, machine/ansi.h does not exist anymore... */
 #if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
 #include <sys/_types.h>
diff -Naur gcc-4.7.1.orig/libgcc/ChangeLog.rtems gcc-4.7.1/libgcc/ChangeLog.rtems
--- gcc-4.7.1.orig/libgcc/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7.1/libgcc/ChangeLog.rtems	2012-06-14 14:07:46.900295803 +0200
@@ -0,0 +1,10 @@
+2012-05-16  Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* config.host (m32r-*-rtems*): Include crtinit.o and crtfinit.o
+     	as extra_parts.
+
+2012-03-08  Sebastian Huber  <sebastian.huber@embedded-brains.de>
+
+        * config.host (powerpc-*-rtems*): Add rs6000/t-savresfgpr to
+        tmake_file.
+
diff -Naur gcc-4.7.1.orig/libgcc/config.host gcc-4.7.1/libgcc/config.host
--- gcc-4.7.1.orig/libgcc/config.host	2012-04-30 19:39:57.000000000 +0200
+++ gcc-4.7.1/libgcc/config.host	2012-06-14 14:07:46.901295813 +0200
@@ -690,6 +690,7 @@
  	;;
 m32r-*-rtems*)
 	tmake_file="$tmake_file m32r/t-m32r t-fdpbit"
+	extra_parts="$extra_parts crtinit.o crtfini.o"
 	;;
 m32rle-*-elf*)
 	tmake_file=t-fdpbit
@@ -888,7 +889,7 @@
 	extra_parts="$extra_parts crtbegin.o crtend.o crtbeginS.o crtendS.o crtbeginT.o ecrti.o ecrtn.o ncrti.o ncrtn.o"
 	;;
 powerpc-*-rtems*)
-	tmake_file="${tmake_file} rs6000/t-ppccomm rs6000/t-crtstuff t-crtstuff-pic t-fdpbit"
+	tmake_file="${tmake_file} rs6000/t-ppccomm rs6000/t-savresfgpr rs6000/t-crtstuff t-crtstuff-pic t-fdpbit"
 	extra_parts="$extra_parts crtbeginS.o crtendS.o crtbeginT.o ecrti.o ecrtn.o ncrti.o ncrtn.o"
 	;;
 powerpc-*-linux* | powerpc64-*-linux*)