diff -Naur gcc-4.8.0.orig/gcc/ChangeLog gcc-4.8.0/gcc/ChangeLog
--- gcc-4.8.0.orig/gcc/ChangeLog	2013-03-22 11:04:30.000000000 +0100
+++ gcc-4.8.0/gcc/ChangeLog	2013-03-26 16:25:34.772043578 +0100
@@ -1,3 +1,7 @@
+2013-03-26  Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* config/v850/t-rtems: Use multilibs from gcc < 4.8.0.
+
 2013-03-22  Release Manager
 
 	* GCC 4.8.0 released.
diff -Naur gcc-4.8.0.orig/gcc/ChangeLog.rtems gcc-4.8.0/gcc/ChangeLog.rtems
--- gcc-4.8.0.orig/gcc/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.8.0/gcc/ChangeLog.rtems	2013-03-26 16:25:34.772043578 +0100
@@ -0,0 +1,31 @@
+2012-10-26  Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* config/v850/rtems.h: Undef WCHAR_TYPE_SIZE, WCHAR_TYPE.
+
+2012-01-10	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/h8300/h8300.h: Apply DJ Delorie's patch from 
+	http://gcc.gnu.org/bugzilla/show_bug.cgi?id=48231#c1.
+
+2010-04-19	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _X86_64_ANSI_H_ is 
+	defined (Used by amd64-*-netbsdelf5.*).
+
+2010-04-18	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _I386_ANSI_H_ is 
+	defined (Used by i386-*-netbsdelf5.*).
+
+2009-11-04	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/m32c/rtems.h, config/m68k/rtemself.h,
+	config/m68k/rtemself.h, config/sh/rtemself.h,
+	config/sparc/rtemself.h: Undef WCHAR_TYPE_SIZE, WCHAR_TYPE. 
+	(Resets WCHAR_TYPE's to defaults. Prevents broken GCC tm_files 
+	to interfere and cause wchar_t/wint_t incompatibilities).
+
+		Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/mips/elf.h: Remove NO_IMPLICIT_EXTERN_C.
+	
diff -Naur gcc-4.8.0.orig/gcc/config/h8300/h8300.h gcc-4.8.0/gcc/config/h8300/h8300.h
--- gcc-4.8.0.orig/gcc/config/h8300/h8300.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/h8300/h8300.h	2013-03-26 16:25:34.772043578 +0100
@@ -127,6 +127,7 @@
 #define INCOMING_FRAME_SP_OFFSET   (POINTER_SIZE / 8)
 
 #define DWARF_CIE_DATA_ALIGNMENT	2
+#define DWARF2_ADDR_SIZE		4
 
 /* Define this if addresses of constant functions
    shouldn't be put through pseudo regs where they can be cse'd.
diff -Naur gcc-4.8.0.orig/gcc/config/m32c/rtems.h gcc-4.8.0/gcc/config/m32c/rtems.h
--- gcc-4.8.0.orig/gcc/config/m32c/rtems.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/m32c/rtems.h	2013-03-26 16:25:34.772043578 +0100
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.8.0.orig/gcc/config/m68k/rtemself.h gcc-4.8.0/gcc/config/m68k/rtemself.h
--- gcc-4.8.0.orig/gcc/config/m68k/rtemself.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/m68k/rtemself.h	2013-03-26 16:25:34.773043599 +0100
@@ -31,3 +31,8 @@
 	builtin_assert ("system=rtems");	\
     }						\
   while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.8.0.orig/gcc/config/mips/elf.h gcc-4.8.0/gcc/config/mips/elf.h
--- gcc-4.8.0.orig/gcc/config/mips/elf.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/mips/elf.h	2013-03-26 16:25:34.773043599 +0100
@@ -46,5 +46,3 @@
 
 #undef  ENDFILE_SPEC
 #define ENDFILE_SPEC "crtend%O%s crtn%O%s"
-
-#define NO_IMPLICIT_EXTERN_C 1
diff -Naur gcc-4.8.0.orig/gcc/config/rs6000/rtems.h gcc-4.8.0/gcc/config/rs6000/rtems.h
--- gcc-4.8.0.orig/gcc/config/rs6000/rtems.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/rs6000/rtems.h	2013-03-26 16:25:34.773043599 +0100
@@ -54,3 +54,7 @@
 #undef  SUBSUBTARGET_EXTRA_SPECS
 #define SUBSUBTARGET_EXTRA_SPECS \
   { "cpp_os_rtems",		CPP_OS_RTEMS_SPEC }
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.8.0.orig/gcc/config/sh/rtemself.h gcc-4.8.0/gcc/config/sh/rtemself.h
--- gcc-4.8.0.orig/gcc/config/sh/rtemself.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/sh/rtemself.h	2013-03-26 16:25:34.773043599 +0100
@@ -24,3 +24,8 @@
   builtin_define( "__rtems__" );		\
   builtin_assert( "system=rtems" );		\
 } while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.8.0.orig/gcc/config/sparc/rtemself.h gcc-4.8.0/gcc/config/sparc/rtemself.h
--- gcc-4.8.0.orig/gcc/config/sparc/rtemself.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/sparc/rtemself.h	2013-03-26 16:25:34.773043599 +0100
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.8.0.orig/gcc/config/sparc/sp64-rtemself.h gcc-4.8.0/gcc/config/sparc/sp64-rtemself.h
--- gcc-4.8.0.orig/gcc/config/sparc/sp64-rtemself.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.8.0/gcc/config/sparc/sp64-rtemself.h	2013-03-26 16:25:34.774043617 +0100
@@ -0,0 +1,37 @@
+/* Definitions for rtems targeting a SPARC64 using ELF.
+   Copyright (C) 2010 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+/* Target OS builtins.  */
+#undef TARGET_OS_CPP_BUILTINS
+#define TARGET_OS_CPP_BUILTINS()		\
+  do						\
+    {						\
+	builtin_define ("__rtems__");		\
+	builtin_define ("__USE_INIT_FINI__");	\
+	builtin_assert ("system=rtems");	\
+    }						\
+  while (0)
+
+/* Use the default */
+#undef LINK_GCC_C_SEQUENCE_SPEC
+
+/* we are not svr4 */
+#undef CPP_SUBTARGET_SPEC
+#define CPP_SUBTARGET_SPEC ""
diff -Naur gcc-4.8.0.orig/gcc/config/v850/rtems.h gcc-4.8.0/gcc/config/v850/rtems.h
--- gcc-4.8.0.orig/gcc/config/v850/rtems.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/config/v850/rtems.h	2013-03-26 16:25:34.774043617 +0100
@@ -34,3 +34,8 @@
 %{!mv850es:%{!mv850e1:%{mv*:-mv%*}} \
 %{m8byte-align:-m8byte-align} \
 %{mgcc-abi:-mgcc-abi}}"
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.8.0.orig/gcc/config/v850/t-rtems gcc-4.8.0/gcc/config/v850/t-rtems
--- gcc-4.8.0.orig/gcc/config/v850/t-rtems	2012-07-18 17:29:51.000000000 +0200
+++ gcc-4.8.0/gcc/config/v850/t-rtems	2013-03-26 16:25:34.774043617 +0100
@@ -1,3 +1,8 @@
 # Custom multilibs for RTEMS
 
+# Multilibs from gcc-4.7.x
+MULTILIB_OPTIONS  = mv850/mv850e/mv850e2/mv850e2v3
+MULTILIB_DIRNAMES = v850 v850e v850e2 v850e2v3
+MULTILIB_MATCHES  = mv850e=mv850e1 
+
 MULTILIB_MATCHES  += mv850e=mv850es
diff -Naur gcc-4.8.0.orig/gcc/ginclude/stddef.h gcc-4.8.0/gcc/ginclude/stddef.h
--- gcc-4.8.0.orig/gcc/ginclude/stddef.h	2013-01-10 21:38:27.000000000 +0100
+++ gcc-4.8.0/gcc/ginclude/stddef.h	2013-03-26 16:25:34.774043617 +0100
@@ -50,7 +50,13 @@
    one less case to deal with in the following.  */
 #if defined (__BSD_NET2__) || defined (____386BSD____) || (defined (__FreeBSD__) && (__FreeBSD__ < 5)) || defined(__NetBSD__)
 #include <machine/ansi.h>
+#if !defined(_MACHINE_ANSI_H_)
+#if defined(_I386_ANSI_H_) || defined(_X86_64_ANSI_H_)
+#define _MACHINE_ANSI_H_
 #endif
+#endif
+#endif
+
 /* On FreeBSD 5, machine/ansi.h does not exist anymore... */
 #if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
 #include <sys/_types.h>