diff -Naur gcc-4.5.1.orig/ChangeLog.rtems gcc-4.5.1/ChangeLog.rtems
--- gcc-4.5.1.orig/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.1/ChangeLog.rtems	2010-08-15 08:39:42.577094301 +0200
@@ -0,0 +1,4 @@
+2008-02-05	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* configure, configure.ac (skipdirs): Add target-libiberty.
+
diff -Naur gcc-4.5.1.orig/configure gcc-4.5.1/configure
--- gcc-4.5.1.orig/configure	2010-06-24 23:06:37.000000000 +0200
+++ gcc-4.5.1/configure	2010-08-15 08:39:42.581093764 +0200
@@ -3291,6 +3291,7 @@
     noconfigdirs="$noconfigdirs target-newlib target-libiberty target-libgloss ${libgcj} target-libmudflap"
     ;;
   *-*-rtems*)
+    skipdirs="$skipdirs target-libiberty"
     noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
     ;;
     # The tpf target doesn't support gdb yet.
@@ -7977,7 +7978,7 @@
        # to it.  This is right: we don't want to search that directory
        # for binaries, but we want the header files in there, so add
        # them explicitly.
-       FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/$(HOST_SUBDIR)/gcc/include'
+       FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/$(HOST_SUBDIR)/gcc/include -isystem $$r/$(HOST_SUBDIR)/gcc/include-fixed'
 
        # Someone might think of using the pre-installed headers on
        # Canadian crosses, in case the installed compiler is not fully
diff -Naur gcc-4.5.1.orig/configure.ac gcc-4.5.1/configure.ac
--- gcc-4.5.1.orig/configure.ac	2010-06-24 23:06:37.000000000 +0200
+++ gcc-4.5.1/configure.ac	2010-08-15 08:39:42.583099133 +0200
@@ -528,6 +528,7 @@
     noconfigdirs="$noconfigdirs target-newlib target-libiberty target-libgloss ${libgcj} target-libmudflap"
     ;;
   *-*-rtems*)
+    skipdirs="$skipdirs target-libiberty"
     noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
     ;;
     # The tpf target doesn't support gdb yet.
@@ -3030,7 +3031,7 @@
        # to it.  This is right: we don't want to search that directory
        # for binaries, but we want the header files in there, so add
        # them explicitly.
-       FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/$(HOST_SUBDIR)/gcc/include'
+       FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/$(HOST_SUBDIR)/gcc/include -isystem $$r/$(HOST_SUBDIR)/gcc/include-fixed'
 
        # Someone might think of using the pre-installed headers on
        # Canadian crosses, in case the installed compiler is not fully
diff -Naur gcc-4.5.1.orig/gcc/ChangeLog.rtems gcc-4.5.1/gcc/ChangeLog.rtems
--- gcc-4.5.1.orig/gcc/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.1/gcc/ChangeLog.rtems	2010-08-18 03:53:57.103665964 +0200
@@ -0,0 +1,52 @@
+2010-08-17  	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config.gcc (bfin*-rtems*): Add newlib-stdint.h.
+	* config.gcc (lm32*-rtems*): Add newlib-stdint.h.
+
+2010-05-19  Joel Sherrill <joel.sherrill@oarcorp.com>
+
+    	* config.gcc (sparc64-*-rtems*): New target.
+	* config/sparc/sp64-rtemself.h: New file.
+
+2010-04-19	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _X86_64_ANSI_H_ is 
+	defined (Used by amd64-*-netbsdelf5.*).
+
+2010-04-18	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _I386_ANSI_H_ is 
+	defined (Used by i386-*-netbsdelf5.*).
+
+2010-03-15	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	Patch from Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>:
+	* config/arm/rtems-elf.h, config/arm/t-rtems: Add optional support
+	for vfp FPU model
+
+2009-12-01	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/avr/avr.h (LINK_SPEC): Pass -m avrN to ld for -mmcu=avrN.
+
+2009-11-04	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/m32c/rtems.h, config/m68k/rtemself.h,
+	config/m68k/rtemself.h, config/sh/rtemself.h,
+	config/sparc/rtemself.h: Undef WCHAR_TYPE_SIZE, WCHAR_TYPE. 
+	(Resets WCHAR_TYPE's to defaults. Prevents broken GCC tm_files 
+	to interfere and cause wchar_t/wint_t incompatibilities).
+
+2009-10-15	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/avr/t-rtems: Don't build _exit.
+
+		Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/rs6000/rtems.h: Support for custom RTEMS multilibs.
+	Support TARGET_E500.
+	* config/rs6000/t-rtems: Custom RTEMS multilibs. 
+
+		Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/mips/elf.h: Remove NO_IMPLICIT_EXTERN_C.
+	
diff -Naur gcc-4.5.1.orig/gcc/config/arm/rtems-elf.h gcc-4.5.1/gcc/config/arm/rtems-elf.h
--- gcc-4.5.1.orig/gcc/config/arm/rtems-elf.h	2009-03-25 13:54:16.000000000 +0100
+++ gcc-4.5.1/gcc/config/arm/rtems-elf.h	2010-08-15 08:39:42.583099133 +0200
@@ -36,7 +36,7 @@
  */
 #undef SUBTARGET_EXTRA_ASM_SPEC
 #define SUBTARGET_EXTRA_ASM_SPEC "\
-  %{!mhard-float: %{!msoft-float:-mfpu=softfpa}}"
+  %{!mhard-float: %{!mfpu=vfp: %{!msoft-float:-mfpu=softfpa}}}"
 
 /*
  *  The default includes --start-group and --end-group which conflicts
diff -Naur gcc-4.5.1.orig/gcc/config/arm/t-rtems gcc-4.5.1/gcc/config/arm/t-rtems
--- gcc-4.5.1.orig/gcc/config/arm/t-rtems	2004-11-23 06:30:32.000000000 +0100
+++ gcc-4.5.1/gcc/config/arm/t-rtems	2010-08-15 08:39:42.584094185 +0200
@@ -5,6 +5,41 @@
 MULTILIB_EXCEPTIONS  = 
 MULTILIB_MATCHES     = marm=mno-thumb
 
-MULTILIB_OPTIONS    += msoft-float/mhard-float
-MULTILIB_DIRNAMES   += soft fpu
-MULTILIB_EXCEPTIONS += *mthumb/*mhard-float*
+MULTILIB_OPTIONS    += mhard-float/mfloat-abi=softfp
+MULTILIB_DIRNAMES   += fpu softfp
+MULTILIB_EXCEPTIONS += *mthumb*/*mhard-float* *mthumb*/*mfloat-abi=softfp*
+MULTILIB_MATCHES     =
+
+MULTILIB_OPTIONS    += mfpu=vfp
+MULTILIB_DIRNAMES   += vfp
+MULTILIB_EXCEPTIONS += *mhard-float*/*mfpu=vfp* *marm*/*mfloat-abi=softfp*/*mfpu=fpa*
+MULTILIB_EXCLUSIONS += !mthumb/mfloat-abi=softfp/!mfpu=vfp
+
+# default float model is fpa, so don't create a explicit copy of it
+MULTILIB_EXCEPTIONS += *marm*/*mfpa*
+
+# permutations of the options which are useful (+) or make no sense (-),
+# defaults are in brackets:
+# + (arm/soft/fpa)
+# + (arm/soft)/vfp
+# - (arm)/softfp(/fpa)
+# + (arm)/softfp/vfp
+# + (arm)/hard-float(/fpa)
+# - (arm)/hard-float/vfp
+# + thumb/(soft/fpa)
+# + thumb/(soft/)vfp
+# - thumb/softfp/fpa
+# - thumb/softfp/vfp
+# - thumb/hard-float/fpa
+# - thumb/hard-float/vfp
+
+# subdirs to be used for multilibs and their respective options:
+#/thumb/vfp  -> thumb/soft/vfp
+#/thumb/fpa  -> thumb/soft/fpa
+#/thumb      -> thumb/soft/fpa
+#/vfp        -> arm/soft/vfp
+#/softfp/vfp -> arm/softfp/cfp
+#/fpu/fpa    -> arm/hard/fpa
+#/fpu        -> arm/hard/fpa
+#/fpa        -> arm/soft/fpa
+#.           -> arm/soft/fpa
diff -Naur gcc-4.5.1.orig/gcc/config/avr/t-rtems gcc-4.5.1/gcc/config/avr/t-rtems
--- gcc-4.5.1.orig/gcc/config/avr/t-rtems	2004-11-23 04:44:03.000000000 +0100
+++ gcc-4.5.1/gcc/config/avr/t-rtems	2010-08-15 08:39:42.584094185 +0200
@@ -1,3 +1,4 @@
 # Multilibs for avr RTEMS targets.
 
-# ATM, this is just a stub
+# RTEMS uses _exit from newlib
+LIB1ASMFUNCS := $(filter-out _exit,$(LIB1ASMFUNCS))
diff -Naur gcc-4.5.1.orig/gcc/config/m32c/rtems.h gcc-4.5.1/gcc/config/m32c/rtems.h
--- gcc-4.5.1.orig/gcc/config/m32c/rtems.h	2008-12-01 17:34:42.000000000 +0100
+++ gcc-4.5.1/gcc/config/m32c/rtems.h	2010-08-15 08:39:42.584094185 +0200
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.1.orig/gcc/config/m68k/rtemself.h gcc-4.5.1/gcc/config/m68k/rtemself.h
--- gcc-4.5.1.orig/gcc/config/m68k/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.1/gcc/config/m68k/rtemself.h	2010-08-15 08:39:42.584094185 +0200
@@ -31,3 +31,8 @@
 	builtin_assert ("system=rtems");	\
     }						\
   while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.1.orig/gcc/config/mips/elf.h gcc-4.5.1/gcc/config/mips/elf.h
--- gcc-4.5.1.orig/gcc/config/mips/elf.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.1/gcc/config/mips/elf.h	2010-08-15 08:39:42.584094185 +0200
@@ -48,6 +48,4 @@
 #undef  ENDFILE_SPEC
 #define ENDFILE_SPEC "crtend%O%s crtn%O%s"
 
-#define NO_IMPLICIT_EXTERN_C 1
-
 #define HANDLE_PRAGMA_PACK_PUSH_POP 1
diff -Naur gcc-4.5.1.orig/gcc/config/rs6000/rtems.h gcc-4.5.1/gcc/config/rs6000/rtems.h
--- gcc-4.5.1.orig/gcc/config/rs6000/rtems.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.1/gcc/config/rs6000/rtems.h	2010-08-15 08:39:42.585093940 +0200
@@ -49,8 +49,22 @@
 %{mcpu=604:  %{!Dppc*: %{!Dmpc*: -Dmpc604}  } } \
 %{mcpu=750:  %{!Dppc*: %{!Dmpc*: -Dmpc750}  } } \
 %{mcpu=821:  %{!Dppc*: %{!Dmpc*: -Dmpc821}  } } \
-%{mcpu=860:  %{!Dppc*: %{!Dmpc*: -Dmpc860}  } }" 
+%{mcpu=860:  %{!Dppc*: %{!Dmpc*: -Dmpc860}  } } \
+%{mcpu=8540: %{!Dppc*: %{!Dmpc*: -Dppc8540}  } }" 
 
 #undef  SUBSUBTARGET_EXTRA_SPECS
 #define SUBSUBTARGET_EXTRA_SPECS \
   { "cpp_os_rtems",		CPP_OS_RTEMS_SPEC }
+
+#undef SUBSUBTARGET_OVERRIDE_OPTIONS
+#define SUBSUBTARGET_OVERRIDE_OPTIONS		\
+  do {						\
+    if (TARGET_E500)				\
+      {						\
+	rs6000_float_gprs = 1;			\
+      }						\
+  } while(0)
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.1.orig/gcc/config/rs6000/t-rtems gcc-4.5.1/gcc/config/rs6000/t-rtems
--- gcc-4.5.1.orig/gcc/config/rs6000/t-rtems	2009-04-21 21:03:23.000000000 +0200
+++ gcc-4.5.1/gcc/config/rs6000/t-rtems	2010-08-15 08:39:42.585093940 +0200
@@ -19,12 +19,12 @@
 # <http://www.gnu.org/licenses/>.
 
 MULTILIB_OPTIONS	= \
-mcpu=403/mcpu=505/mcpu=601/mcpu=603e/mcpu=604/mcpu=860/mcpu=7400 \
+mcpu=403/mcpu=505/mcpu=601/mcpu=603e/mcpu=604/mcpu=860/mcpu=7400/mcpu=8540 \
 Dmpc8260 \
 msoft-float
 
 MULTILIB_DIRNAMES	= \
-m403 m505 m601 m603e m604 m860 m7400 \
+m403 m505 m601 m603e m604 m860 m7400 m8540 \
 mpc8260 \
 nof
 
@@ -47,6 +47,10 @@
 # Map 750 to .
 MULTILIB_MATCHES	+= mcpu?750=
 
+# Map e500, 8548 to 8540
+MULTILIB_MATCHES	+= mcpu?8540=mcpu?e500
+MULTILIB_MATCHES	+= mcpu?8540=mcpu?8548
+
 # Soft-float only, default implies msoft-float
 # NOTE: Must match with MULTILIB_MATCHES_FLOAT and MULTILIB_MATCHES
 MULTILIB_SOFTFLOAT_ONLY = \
@@ -80,3 +84,4 @@
 MULTILIB_EXCEPTIONS += *mcpu=750/Dmpc*
 MULTILIB_EXCEPTIONS += *mcpu=860/Dmpc*
 MULTILIB_EXCEPTIONS += *mcpu=7400/Dmpc*
+MULTILIB_EXCEPTIONS += *mcpu=8540/Dmpc*
diff -Naur gcc-4.5.1.orig/gcc/config/sh/rtemself.h gcc-4.5.1/gcc/config/sh/rtemself.h
--- gcc-4.5.1.orig/gcc/config/sh/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.1/gcc/config/sh/rtemself.h	2010-08-15 08:39:42.585093940 +0200
@@ -24,3 +24,8 @@
   builtin_define( "__rtems__" );		\
   builtin_assert( "system=rtems" );		\
 } while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.1.orig/gcc/config/sparc/rtemself.h gcc-4.5.1/gcc/config/sparc/rtemself.h
--- gcc-4.5.1.orig/gcc/config/sparc/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.1/gcc/config/sparc/rtemself.h	2010-08-15 08:39:42.585093940 +0200
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.1.orig/gcc/config/sparc/sp64-rtemself.h gcc-4.5.1/gcc/config/sparc/sp64-rtemself.h
--- gcc-4.5.1.orig/gcc/config/sparc/sp64-rtemself.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.1/gcc/config/sparc/sp64-rtemself.h	2010-08-15 08:39:42.585093940 +0200
@@ -0,0 +1,37 @@
+/* Definitions for rtems targeting a SPARC64 using ELF.
+   Copyright (C) 2010 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+/* Target OS builtins.  */
+#undef TARGET_OS_CPP_BUILTINS
+#define TARGET_OS_CPP_BUILTINS()		\
+  do						\
+    {						\
+	builtin_define ("__rtems__");		\
+	builtin_define ("__USE_INIT_FINI__");	\
+	builtin_assert ("system=rtems");	\
+    }						\
+  while (0)
+
+/* Use the default */
+#undef LINK_GCC_C_SEQUENCE_SPEC
+
+/* we are not svr4 */
+#undef CPP_SUBTARGET_SPEC
+#define CPP_SUBTARGET_SPEC ""
diff -Naur gcc-4.5.1.orig/gcc/config.gcc gcc-4.5.1/gcc/config.gcc
--- gcc-4.5.1.orig/gcc/config.gcc	2010-07-14 10:41:46.000000000 +0200
+++ gcc-4.5.1/gcc/config.gcc	2010-08-18 04:02:40.859829210 +0200
@@ -854,7 +854,7 @@
 	use_collect2=no
 	;;
 bfin*-rtems*)
-	tm_file="${tm_file} dbxelf.h elfos.h bfin/elf.h bfin/rtems.h rtems.h"
+	tm_file="${tm_file} dbxelf.h elfos.h bfin/elf.h bfin/rtems.h rtems.h newlib-stdint.h"
 	tmake_file="bfin/t-bfin t-rtems bfin/t-rtems"
 	;;
 bfin*-*)
@@ -1523,7 +1523,7 @@
 	tmake_file="${tmake_file} lm32/t-lm32 lm32/t-fprules-softfp soft-fp/t-softfp"
         ;;
 lm32-*-rtems*)
-	tm_file="dbxelf.h elfos.h ${tm_file} lm32/rtems.h rtems.h"
+	tm_file="dbxelf.h elfos.h ${tm_file} lm32/rtems.h rtems.h newlib-stdint.h"
 	tmake_file="${tmake_file} lm32/t-lm32 lm32/t-fprules-softfp soft-fp/t-softfp"
 	tmake_file="${tmake_file} t-rtems"
          ;;
@@ -2407,6 +2407,12 @@
 	tmake_file="sparc/t-elf sparc/t-crtfm t-rtems"
 	extra_parts="crti.o crtn.o crtbegin.o crtend.o"
 	;;
+sparc64-*-rtems*)
+	tm_file="${tm_file} dbxelf.h elfos.h svr4.h newlib-stdint.h sparc/sysv4.h sparc/sp64-elf.h sparc/sp64-rtemself.h rtems.h"
+	extra_options="${extra_options} sparc/little-endian.opt"
+	tmake_file="${tmake_file} sparc/t-crtfm t-rtems"
+	extra_parts="crtbegin.o crtend.o"
+	;;
 sparc*-*-solaris2*)
 	tm_file="sparc/biarch64.h ${tm_file} dbxelf.h elfos.h svr4.h sparc/sysv4.h sol2.h"
 	case ${target} in
diff -Naur gcc-4.5.1.orig/gcc/ginclude/stddef.h gcc-4.5.1/gcc/ginclude/stddef.h
--- gcc-4.5.1.orig/gcc/ginclude/stddef.h	2009-04-09 17:00:19.000000000 +0200
+++ gcc-4.5.1/gcc/ginclude/stddef.h	2010-08-15 08:39:42.587093998 +0200
@@ -53,7 +53,13 @@
    one less case to deal with in the following.  */
 #if defined (__BSD_NET2__) || defined (____386BSD____) || (defined (__FreeBSD__) && (__FreeBSD__ < 5)) || defined(__NetBSD__)
 #include <machine/ansi.h>
+#if !defined(_MACHINE_ANSI_H_)
+#if defined(_I386_ANSI_H_) || defined(_X86_64_ANSI_H_)
+#define _MACHINE_ANSI_H_
 #endif
+#endif
+#endif
+
 /* On FreeBSD 5, machine/ansi.h does not exist anymore... */
 #if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
 #include <sys/_types.h>
diff -Naur gcc-4.5.1.orig/libgcc/ChangeLog.rtems gcc-4.5.1/libgcc/ChangeLog.rtems
--- gcc-4.5.1.orig/libgcc/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.1/libgcc/ChangeLog.rtems	2010-08-18 03:51:46.973666381 +0200
@@ -0,0 +1,9 @@
+2010-08-17  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	1669/Tools, GCC-BZ 44793
+	* config.host (powerpc-*-rtems*): Add tmake_file.
+	Add extra_parts.
+
+2010-05-19  Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* config.host (sparc64-*-rtems*): New target.
diff -Naur gcc-4.5.1.orig/libgcc/config.host gcc-4.5.1/libgcc/config.host
--- gcc-4.5.1.orig/libgcc/config.host	2010-04-15 18:08:30.000000000 +0200
+++ gcc-4.5.1/libgcc/config.host	2010-08-17 18:29:59.528093851 +0200
@@ -466,6 +466,8 @@
 powerpc-*-eabi*)
 	;;
 powerpc-*-rtems*)
+	tmake_file="${tmake_file} rs6000/t-ppccomm t-softfp"
+	extra_parts="crtbegin.o crtend.o crtbeginS.o crtendS.o crtbeginT.o"
 	;;
 powerpc-*-linux* | powerpc64-*-linux*)
 	tmake_file="${tmake_file} rs6000/t-ppccomm rs6000/t-ldbl128 t-softfp"
@@ -535,7 +537,7 @@
 	extra_parts="$extra_parts crtfastmath.o"
 	tmake_file="${tmake_file} sparc/t-crtfm"
 	;;
-sparc-*-rtems*)
+sparc-*-rtems* | sparc64-*-rtems* )
 	;;
 sparc64-*-solaris2* | sparcv9-*-solaris2*)
 	;;